import { type BytesLike, type Signer } from "ethers";
import type { DeployOptions } from "../../types/deploy/deploy-options";
/**
 * Deploy a contract at a deterministic address, using Create2 method
 * Address depends on the Create2 factory address.
 *
 * @internal
 *
 * @param signer - The signer to use
 * @param bytecode - The bytecode to deploy
 * @param encodedArgs - The encoded constructor args to use
 * @param create2FactoryAddress - The create2 factory address to use
 */
export declare function deployContractDeterministicRaw(signer: Signer, bytecode: string, encodedArgs: BytesLike, create2FactoryAddress: string, options?: DeployOptions, predictedAddress?: string, gasLimit?: number): Promise<void>;
//# sourceMappingURL=deployContractDeterministicRaw.d.ts.map